// Point2DTrial.cpp: implementation of the CPoint2DTrial class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "winwapwad.h"
#include "session.h"
#include "t_data.h"

#include "Point2DTrial.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
IMPLEMENT_DYNCREATE (CPoint2DTrial, CObject);

CPoint2DTrial::CPoint2DTrial()
{

}

CPoint2DTrial::~CPoint2DTrial()
{

}

trial_data* CPoint2DTrial::NewInstance (int dist, int diam, int ang, bool collectTrail)
{
	CPoint2DTrial* pTrial= (CPoint2DTrial *) ((RUNTIME_CLASS (CPoint2DTrial))->CreateObject ());
	pTrial->InitInstance (dist, diam, ang, collectTrail);
	return (trial_data*) pTrial;
}

void CPoint2DTrial::InitInstance (int dist, int diam, int ang, bool collectTrail)
{
	target_distance = dist;
	target_diameter = diam;
	target_angle = ang;
	if (collectTrail)
	{
		trail.reserve (TRAIL_START_SIZE);
	}
}

trial_data* CPoint2DTrial::copy_instance ()
{
	trial_data* trial = NewInstance (target_distance, target_diameter, target_angle, trail.capacity () != 0);
	trial->sess = sess;
	return trial;
}

double CPoint2DTrial::GetTargetDiameter ()
{
	return target_diameter / DIST_UNIT;
}

double CPoint2DTrial::GetTargetDistance ()
{
	return target_distance / DIST_UNIT;
}

int CPoint2DTrial::GetTargetAngle ()
{
	return target_angle;
}

void CPoint2DTrial::ClickInsideHome (float x, float y, int time, time_t clickTimeOfDay)
{
	start_time = clickTimeOfDay;
	add_sample (x, y, time, Sample::BUTTON_UP);
}

void CPoint2DTrial::ClickInsideTarget (float x, float y, int time)
{
	x_target_off = x;
	y_target_off = y;
	trial_time = time;
	tooLarge = false;
	error = false;
	add_sample (x, y, time, Sample::CLICK_INSIDE_TARGET);
}

void CPoint2DTrial::ClickOutsideTarget (float x, float y, int time)
{
	x_target_off = x;
	y_target_off = y;
	trial_time = time;
	tooLarge = false;
	error = true;
	add_sample (x, y, time, Sample::CLICK_OUTSIDE_TARGET);
}

void CPoint2DTrial::StopSession (int time)
{
	// Just fake the mouse position, since it's been moved to make a menu selection
	// (and it's hard to find the current mouse position at this point anyways)
	x_target_off = 0;
	y_target_off = 0;

	trial_time = time;
	tooLarge = false;
	error = true;
	sess->stop_session ();
	add_sample (x_target_off, y_target_off, time, Sample::SESSION_STOPPED);
}


void CPoint2DTrial::MouseMove (float x, float y, int time)
{
	add_sample (x, y, time, Sample::BUTTON_UP);
}

void CPoint2DTrial::TooLarge ()
{
	tooLarge = true;
}
