// SessionID.cpp : implementation file
//

#include "stdafx.h"

#include <iomanip.h>

#include "winwapwad.h"
#include "SessionID.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSessionID dialog


CSessionID::CSessionID(bool recordTrails, CWnd* pParent /*=NULL*/)
	: CDialog(CSessionID::IDD, pParent)
{
	m_bRecordTrails = recordTrails;
	//{{AFX_DATA_INIT(CSessionID)
	m_ParticipantId = _T("");
	m_SessionNum = _T("");
	//}}AFX_DATA_INIT
	out = NULL;
}


void CSessionID::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSessionID)
	DDX_Text(pDX, IDC_PARTICIPANT_ID, m_ParticipantId);
	DDV_MaxChars(pDX, m_ParticipantId, 30);
	DDX_Text(pDX, IDC_SESSION_NUM, m_SessionNum);
	DDV_MaxChars(pDX, m_SessionNum, 10);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSessionID, CDialog)
	//{{AFX_MSG_MAP(CSessionID)
	ON_BN_CLICKED(IDOK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSessionID message handlers

void CSessionID::OnOk() 
{
	CDialog::OnOK ();

	{	// Scope the extent of checkFile
		CFileDialog checkFile (false, NULL, m_ParticipantId + m_SessionNum + ".wfs",
			OFN_OVERWRITEPROMPT, NULL, this);
		if (checkFile.DoModal () != IDOK)
		{
			out = NULL;
			trailsOut = NULL;
			return;
		}
		out = new ofstream (checkFile.GetPathName ());
	}
	// Now, we should almost certainly always get the file, since we just verified
	// it exists.  However, just in case something really WEIRD is happening, I
	// check.  However, if something weird is happening, I just punt without 
	// telling the user anything.
	if ( ! out->good ())
	{
		delete out;
		out = NULL;
		trailsOut = NULL;
		return;
	}

	if (m_bRecordTrails)
	{
		CFileDialog checkFile (false, NULL, m_ParticipantId + m_SessionNum + ".wft",
			OFN_OVERWRITEPROMPT, NULL, this);
		if (checkFile.DoModal () != IDOK)
		{
			delete out;
			out = NULL;
			trailsOut = NULL;
			return;
		}
		
		trailsOut = new ofstream (checkFile.GetPathName ());
		// Now, we should almost certainly always get the file, since we just verified
		// it exists.  However, just in case something really WEIRD is happening, I
		// check.  However, if something weird is happening, I just punt without 
		// telling the user anything.
		if ( ! trailsOut->good ())
		{
			delete out;
			out = NULL;
			delete trailsOut;
			trailsOut = NULL;
			return;
		}
		*trailsOut << setiosflags (ios::fixed) << setprecision (1);
	}
	else
		trailsOut = NULL;
}

void CSessionID::OnCancel() 
{
	// TODO: Add extra cleanup here
	out = NULL;
	trailsOut = NULL;
	CDialog::OnCancel();
}
