/*************************************************************************
 FILE:				DTD_DB.H     
 CREATION DATE:		14 May 1996
 LAST MODIFIED:		26 May 1996
 AUTHOR:			Chris Hundhausen 
 COPYRIGHT:			(c) 1996 by 
 					Interactive Systems Group
 					Department of Computer and Information Science
 			 		University of Oregon
 			 		Eugene, OR  97403-1202
 			 		All rights reserved.	
 =========================================================================
 DESCRIPTION:
 This file implements the dtd_Database class defined in "dtd_db.h".
*************************************************************************/  

#include "stdafx.h"
#include "dtd_db.h"
#include <string.h>
#include <strstrea.h>

dtd_database::dtd_database() : lookup_list() {}

BOOL dtd_database::add_mapping(dtd_database::data_task_def *d_t_d) {
	lookup_list.append(d_t_d);
	return TRUE;
}
		
	
dtd_database::data_task_def* dtd_database::retrieve_mapping(const char *lbl) {  
	data_task_def *dtd_ptr;
	int success = lookup_list.first();
	dtd_ptr = (data_task_def*)(lookup_list.current());
	BOOL found = FALSE;
	while ((success) && (found == FALSE)) {
		dtd_ptr = (data_task_def*)(lookup_list.current());
		if (_stricmp(lbl,dtd_ptr->label) == 0)
			found = TRUE;
		else 
		 	success = lookup_list.next();
	}
	if (found == TRUE)
		return dtd_ptr;
	else
		return NULL;
}

list* dtd_database::get_all_labels() { 
    char *str;
    list *li = new list();
    int success = lookup_list.first();
    while (success) {
    	str = new char[40];
    	ostrstream stream(str,40);
    	stream << ((data_task_def*)(lookup_list.current()))->label << '\0';
    	li->append(str);
    	success = lookup_list.next();
    }
    return li;
}

dtd_database::~dtd_database() {} 				
