/*************************************************************************
 FILE:				EX_SES.CPP     
 CREATION DATE:		21 May 1996
 LAST MODIFIED:		21 May 1996
 AUTHOR:			Chris Hundhausen 
 COPYRIGHT:			(c) 1996 by 
 					Interactive Systems Group
 					Department of Computer and Information Science
 			 		University of Oregon
 			 		Eugene, OR  97403-1202
 			 		All rights reserved.	
 =========================================================================
 DESCRIPTION:
 This file implements the experimentor_session class defined in ex_ses.h.
*************************************************************************/  

#include "stdafx.h"
#include "ex_ses.h"

trial_data* experimentor_session::get_next_trial() {   
	trial_data *t1, *t2;
	t1 = ((trial_data*)(pending_trials.dequeue()));
	t2 = new trial_data(*t1); //Invoke copy constructor
	pending_trials.enqueue(t2); // Ensures we'll never run out of trials
	return(t1);
}
					
void experimentor_session::log_trial(trial_data *td) {
	completed_trials.append(td);
	++trials_completed; 
	total_trial_time += td->trial_time;
	mean_trial_time = total_trial_time/trials_completed;
}	

experimentor_session::experimentor_session(int num_trials) 
	: session(num_trials, 1, 3) {}
