/*************************************************************************
 FILE:				PA_SES.H     
 CREATION DATE:		18 May 1996
 LAST MODIFIED:		19 May 1996
 AUTHOR:			Chris Hundhausen 
 COPYRIGHT:			(c) 1996 by 
 					Interactive Systems Group
 					Department of Computer and Information Science
 			 		University of Oregon
 			 		Eugene, OR  97403-1202
 			 		All rights reserved.	
 =========================================================================
 DESCRIPTION:
 This file implements the participant_session class defined in pa_ses.h.
*************************************************************************/  

#include "stdafx.h"
#include "pa_ses.h"

trial_data* participant_session::get_next_trial()
{
	trial_data* result = NULL;
	if (!pending_trials.empty())
	{
		trials_presented++;
		result = ((trial_data*)(pending_trials.dequeue()));
		result->set_trial_seq_num (trials_presented);
	}
	else if ((err_tech == redo_at_end) && (!redo_trials.empty()))
	{
		trials_presented++;
		result = ((trial_data*)(redo_trials.dequeue()));
		result->set_trial_seq_num (trials_presented);
	}
	return result;
}
	
void participant_session::log_trial(trial_data *td) { 
	completed_trials.append(td);
	if (td->error && err_tech ==  redo_at_end) 
	{
		// Don't count as completed trial
		if (trails_out != NULL)
			td->write_trail (*trails_out);
		redo_trials.enqueue(td->copy_instance ());
	}
	else
	{
		++trials_completed; 
		if (trails_out != NULL)
			td->write_trail (*trails_out);
		total_trial_time += td->trial_time;
		mean_trial_time = total_trial_time/trials_completed;
	}
} 

participant_session::participant_session(int num_trials, int blocks, int seed,
		participant_session::ehandling_techniques eht, ofstream* out, ofstream* trails, const CString& partID,
		const CString& sessNum) 
	: session(num_trials, blocks, seed, out, trails, partID, sessNum), redo_trials(num_trials,3) {
	err_tech = eht;
}
	
participant_session::~participant_session()  { 
	trial_data *t;
	while (t = ((trial_data*)(redo_trials.dequeue())))  
		delete t;
}
