/*************************************************************************
 FILE:				PR_SES.CPP     
 CREATION DATE:		20 May 1996
 LAST MODIFIED:		21 May 1996
 AUTHOR:			Chris Hundhausen 
 COPYRIGHT:			(c) 1996 by 
 					Interactive Systems Group
 					Department of Computer and Information Science
 			 		University of Oregon
 			 		Eugene, OR  97403-1202
 			 		All rights reserved.	
 =========================================================================
 DESCRIPTION:
 This file implements the practice_session class defined in pr_ses.h.
*************************************************************************/  

#include "stdafx.h"
#include "pr_ses.h"

trial_data* practice_session::get_next_trial() {   
	trial_data *t1, *t2;
	if (psu == minutes) {
		if (!first_trial_requested)  { 
			time(&session_start_time); // Capture current time
			first_trial_requested = FALSE;
			t1 = ((trial_data*)(pending_trials.dequeue()));
			t2 = new trial_data(*t1); //Invoke copy constructor
			pending_trials.enqueue(t2);
			return t1;
		}
		else  { // must ensure that time hasn't run out 
			// time_t now;
			// time(&now);
			if (((time(NULL) - session_start_time)/60) > session_len)
				//time has run out!
				return NULL;
			else  {  
				t1 = ((trial_data*)(pending_trials.dequeue()));
				t2 = new trial_data(*t1); //Invoke copy constructor
				pending_trials.enqueue(t2);
				return t1;
			}
		}    
	}
	else { //psu == trials
		if (session_len==0) // session is over
			return NULL;
		else {  // Enqueue a copy of next trial before returning it, in
				// order to ensure that we won't run out of trials.  
				t1 = ((trial_data*)(pending_trials.dequeue()));
				t2 = new trial_data(*t1); //Invoke copy constructor
				pending_trials.enqueue(t2);
				session_len--; 
				return t1;
			}

	}
}
					
void practice_session::log_trial(trial_data *td) {
	completed_trials.append(td);
	++trials_completed; 
	total_trial_time += td->trial_time;
	mean_trial_time = total_trial_time/trials_completed;
}	

practice_session::practice_session(int num_trials, 
								   int ses_len, 
								   practice_session::psession_units u)
	: session(num_trials, 1, 2) { 
	
	session_len = ses_len;
	psu = u;
	first_trial_requested = FALSE;
}
