/*************************************************************************
 FILE:				PT_DATA.CPP     
 CREATION DATE:		18 May 1996
 LAST MODIFIED:		18 May 1996
 AUTHOR:			Chris Hundhausen 
 COPYRIGHT:			(c) 1996 by 
 					Interactive Systems Group
 					Department of Computer and Information Science
 			 		University of Oregon
 			 		Eugene, OR  97403-1202
 			 		All rights reserved.	
 =========================================================================
 DESCRIPTION:
 This file implements the perf_trial_data class, as defined in pt_data.h.
*************************************************************************/  

#include "stdafx.h"
#include "pt_data.h"
		
perf_trial_data::perf_trial_data(int diam, int distance, int angle)	
	:trial_data(diam, distance, angle) {
		trial_time = UNDEFINED;
		error = FALSEY;
}
							 	

ofstream& operator << (ofstream& of, perf_trial_data &td) {
	of << td.target_diameter << '\t' << td.target_distance << '\t';
	of << td.target_angle << '\t' << td.trial_time << '\t';
	if (td.error)
		of << "1\n";
	else
		of << "0\n";
	return of;
}
	

