/*************************************************************************
 FILE:				PT_DATA.H     
 CREATION DATE:		18 May 1996
 LAST MODIFIED:		18 May 1996
 AUTHOR:			Chris Hundhausen 
 COPYRIGHT:			(c) 1996 by 
 					Interactive Systems Group
 					Department of Computer and Information Science
 			 		University of Oregon
 			 		Eugene, OR  97403-1202
 			 		All rights reserved.	
 =========================================================================
 DESCRIPTION:
 This file defines 'perf_trial_data', A descendant of trial_data,
 perf_trial_data stores the most basic performance data possible--
 trial time and whether or not an error occurred.
*************************************************************************/  

#ifndef __PT_DATA_H
#define __PT_DATA_H

#include "boolean.h"
#include <fstream.h>
#include "t_data.h"

class perf_trial_data : public trial_data {
	public:
		int trial_time; // How long did trial take?
		boolean error;  // Was the trial an error trial?
		
		// methods
		perf_trial_data(int diam, int distance, int angle);	  
		// GIVEN : A diameter, distance, and angle with which to initialize a new
		//		   instance of trial_data 
		// TASK  : Class constructor:  initialize fresh instance of perf_trial_data.
		// RETURN: A fresh instance of perf_trial_data															 	

		friend ofstream& operator << (ofstream& of, perf_trial_data &td);
		// GIVEN : An ofstream to write to, and a perf_trial_data instance. 
		// TASK  : Write appropriate data fields of perf_trial_data to ofstream. 
		// RETURN: Nothing.
	}; 
	
#endif
