// MODULE  : queue.cpp
// PURPOSE : This module provides the implementation for the queue ADT as
//           defined in queue.h.
// AUTHOR  : Christopher D. Hundhausen
// DATE    : 24 June 1991

#include "stdafx.h"
#include "queue.h"

  queue::queue() // constructor
 {
 front = NULL;
 rear = NULL;
 }

  queue::queue(const queue &q) // copy constructor
 {
 if (q.front == NULL) // empty queue
   {
   front = NULL;
   rear = NULL;
   }
   else // build copy
  {
  queuenode *temp, *n;
  front = new queuenode;
  front->dataptr = q.front->dataptr;
  rear = front;
  temp = q.front->next;
 while (temp != NULL)
   {
	n = new queuenode;
	n->dataptr = temp->dataptr;
	rear->next = n;
	rear = n;
	temp = temp->next;
	}
  rear->next = NULL;
  }
}

  queue::~queue() // destructor
   {
   while (front != NULL)
  {
  queuenode *temp = front;
  front = front->next;
  delete temp;
  }
  }


  void queue::operator = (const queue &q)
   {
   delete this;
   queue temp(q);
   (*this) = temp;
   }

  int queue::empty()
   {
   return (front == NULL);
   }

  void queue::enqueue(void *item) // add item to rear of queue
   {
   queuenode *temp = new queuenode;
	 temp->dataptr = item;
   temp->next = NULL;
   if (front == NULL) // empty queue
   {
   rear = temp;
   front = temp;
   }
   else
   {
   rear->next = temp;
   rear = temp;
   }
  }

  void* queue::dequeue() // remove item from front of queue
  {
   if (front == NULL) // empty queue
   return NULL;
   else
   {
   void* n = front->dataptr;
   queuenode *temp = front;
   front = front->next;
   if (front == NULL) // queue is now empty
	rear = NULL;
   delete temp; // question: will this clobber n?
   return n;
   }
  }






