// sconfigv.cpp : implementation file
//

#include "stdafx.h"
#include "winwapwad.h"
#include "sconfigv.h"
#include "t_data.h"
#include "s_config.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// session_config_view dialog


session_config_view::session_config_view(CWnd* pParent /*=NULL*/, session_config *sc)
	: CDialog(session_config_view::IDD, pParent)
{
	my_sc = sc;
	//{{AFX_DATA_INIT(session_config_view)
	m_ps_len = 0;
	m_ps_units = _T("");
	m_task_type = _T("");
	m_tpc = 0;
	m_ehandle = -1;
	m_hsquare = -1;
	m_collect_data = -1;
	m_targ_angs = _T("");
	m_targ_diams = _T("");
	m_targ_dists = _T("");
	m_save_pdata = -1;
	m_num_blocks = 0;
	//}}AFX_DATA_INIT
}


void session_config_view::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(session_config_view)
	DDX_Text(pDX, IDC_PS_LEN, m_ps_len);
	DDV_MinMaxInt(pDX, m_ps_len, 0, 300);
	DDX_CBString(pDX, IDC_PS_UNITS, m_ps_units);
	DDV_MaxChars(pDX, m_ps_units, 7);
	DDX_CBString(pDX, IDC_TASK_TYPE, m_task_type);
	DDV_MaxChars(pDX, m_task_type, 20);
	DDX_Text(pDX, IDC_TPC, m_tpc);
	DDV_MinMaxInt(pDX, m_tpc, 1, 10);
	DDX_Radio(pDX, IDC_EHANDLE_REDO, m_ehandle);
	DDX_Radio(pDX, IDC_HSQUARE_CENTER, m_hsquare);
	DDX_Radio(pDX, IDC_PERF_DATA, m_collect_data);
	DDX_Text(pDX, IDC_TARG_ANGS, m_targ_angs);
	DDV_MaxChars(pDX, m_targ_angs, 40);
	DDX_Text(pDX, IDC_TARG_DIAMS, m_targ_diams);
	DDV_MaxChars(pDX, m_targ_diams, 40);
	DDX_Text(pDX, IDC_TARG_DISTS, m_targ_dists);
	DDV_MaxChars(pDX, m_targ_dists, 40);
	DDX_Radio(pDX, IDC_PS_SAVE_YES, m_save_pdata);
	DDX_Text(pDX, IDC_NUM_BLOCKS, m_num_blocks);
	DDV_MinMaxInt(pDX, m_num_blocks, 1, 100);
	//}}AFX_DATA_MAP
	//We will ultimately need to perform rigorous error checking on m_targ_dists, m_targ_diams,
	//and m_targ_angs.  To do the error checking, we will need replace the DDX_Text
	//routines that are invoked with m_targ_diams, m_targ_dists, and m_targ_angs as parameters
	//with a custom DDX_NumList(pDX,IDC_TARG_XXX,m_targ_xxxx) routine, which will ensure that
	//the data are in the form of a comma-separated list of integers.  We save this for later;
	//consult the file MSVC20\Samples\Chkbook\dollcent.cpp for insight.
}


BEGIN_MESSAGE_MAP(session_config_view, CDialog)
	//{{AFX_MSG_MAP(session_config_view)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// session_config_view message handlers
BOOL session_config_view::OnInitDialog() {
	int success;
	char str[80];
	ostrstream stream(str,80); 
	//Perform Dialog box initialization here
	// task type
	m_task_type = my_sc->dtd->label;
	// target diameters
	success = my_sc->target_diams.first();
	while (success == TRUE) {
			stream << (*((int *)(my_sc->target_diams.current()))) / DIST_UNIT; 
			if (success = my_sc->target_diams.next())
				stream << ", ";
			else
				stream << '\0'; // null terminate
	}
	m_targ_diams = str;
	stream.seekp(0); //reset stream for next output.
	// target distances
	success = my_sc->target_dists.first();
	while (success == TRUE) {
		stream << (*((int *)(my_sc->target_dists.current()))) / DIST_UNIT; 
		if (success = my_sc->target_dists.next())
			stream << ", ";
		else
			stream << '\0'; // null terminate
	}
	m_targ_dists = str;
	stream.seekp(0); //reset stream for next output.
	// target angles
	success = my_sc->target_angs.first();
	while (success == TRUE) {
		stream << (*((int *)(my_sc->target_angs.current()))); 
		if (success = my_sc->target_angs.next())
			stream << ", ";
		else
			stream << '\0'; // null terminate
	}
	m_targ_angs = str;
	//reset stream for next output.
	stream.seekp(0); 
	// trials per combination
	m_tpc = my_sc->trials_per_comb;
	// number of blocks
	m_num_blocks = my_sc->num_blocks;
	// practice session length
	m_ps_len = my_sc->ps_len;
	// practice session units
	if (my_sc->ps_units == practice_session::minutes)
		m_ps_units = "minutes";
	else
		m_ps_units = "trials";
	// error handling technique
	if (my_sc->err_tech == participant_session::redo_at_end) 
		m_ehandle = 0;
	else 
		m_ehandle = 1;
	// home square placement
	//	cb2 = (CButton *) GetDlgItem(IDC_HSQUARE_RANDOM);
	if (my_sc->home == session_config::center) 
		m_hsquare = 0;
	else
		m_hsquare = 1;
	// data to collect
	if (my_sc->collect_data == session_config::performance) 
		m_collect_data = 0;
	else
		m_collect_data = 1;
	// save practice data?
 	if (my_sc->save_pdata)
		m_save_pdata = 0;
	else
		m_save_pdata = 1;
	return CDialog::OnInitDialog();
}


void session_config_view::OnOK() 	
{
	//First, call parent version, which performs data exchange and validation
	CDialog::OnOK();
	//Second, transfer values from data members into the session_config data member. . .
	//We can assume that all data are completely valid, since the DDX and DDV functions
	//took care of data checking.
	my_sc->ps_len = m_ps_len;
	if (!_stricmp(LPCTSTR(m_ps_units),"minutes"))
		my_sc->ps_units = practice_session::minutes;
	else
		my_sc->ps_units = practice_session::trials;
	my_sc->dtd = my_sc->dtd_db->retrieve_mapping(LPCTSTR(m_task_type));
	my_sc->trials_per_comb = m_tpc; 
	my_sc->num_blocks = m_num_blocks;
	if (m_ehandle)
		my_sc->err_tech = participant_session::dont_redo;
	else
		my_sc->err_tech = participant_session::redo_at_end;
  	if (m_hsquare)
		my_sc->home = session_config::random;
	else
		my_sc->home = session_config::center;
	if (m_collect_data)
		my_sc->collect_data = session_config::micro;
	else 
		my_sc->collect_data = session_config::performance;
	if (m_save_pdata)
		my_sc->save_pdata = FALSE;
	else 
		my_sc->save_pdata = TRUE;
	//OK, now we go about the heinous business of rebuilding the targ_ lists with the
	//new data. . .
	// First, delete the current list items
	int success, len, cur_pos, *cur_int;
	char *str;
	success = my_sc->target_dists.first();
	while (success = my_sc->target_dists.remove());
	success = my_sc->target_diams.first();
	while (success = my_sc->target_diams.remove());
	success = my_sc->target_angs.first();
	while (success = my_sc->target_angs.remove());
	//Next, rebuild the lists with the new data. . .
	//target_dists
	len = m_targ_dists.GetLength();
	str = new char[len + 1];
	strcpy(str,LPCTSTR(m_targ_dists));
	cur_pos = 0;
	do {
		float dist = atof(str + cur_pos);
		cur_int = new int (dist * DIST_UNIT + 0.5F);
		my_sc->target_dists.append(cur_int);
		for (cur_pos;(cur_pos < len) && (str[cur_pos] != ',');++cur_pos);
		++cur_pos; //advance cur_pos past comma
	} while (cur_pos < len);
	delete str;
	//target_diams
	len = m_targ_diams.GetLength();
	str = new char[len + 1];
	strcpy(str,LPCTSTR(m_targ_diams));
	cur_pos = 0;
	do {
		float diam = atof(str + cur_pos);
		cur_int = new int (diam * DIST_UNIT + 0.5F);
		my_sc->target_diams.append(cur_int);
		for (cur_pos;(cur_pos < len) && (str[cur_pos] != ',');++cur_pos);
		++cur_pos; //advance cur_pos past comma
	} while (cur_pos < len);
	delete str;
	//target_angs
	len = m_targ_angs.GetLength();
	str = new char[len + 1];
	strcpy(str,LPCTSTR(m_targ_angs));
	cur_pos = 0;
	do {
		cur_int = new int;
		*cur_int = atoi(str + cur_pos);
		my_sc->target_angs.append(cur_int);
		for (cur_pos;(cur_pos < len) && (str[cur_pos] != ',');++cur_pos);
		++cur_pos; //advance cur_pos past comma
	} while (cur_pos < len);
	delete str;
}
