// winwadoc.h : interface of the CWinwapwadDoc class
//
/////////////////////////////////////////////////////////////////////////////

class session_config; 
class dtd_database;
class session;
class trial_data;

class CWinwapwadDoc : public CDocument
{
public:
   // A CWinwapwadDoc is just a windows-specific session_config.  We'll encapsulate
   // and manage the application data using a session_config data member. . .
	session_config *sc;

protected:
	dtd_database *dtd_db;
	session* currSess;
	trial_data* currTrial;
	CView* currView;

protected: // create from serialization only
	CWinwapwadDoc();
	DECLARE_DYNCREATE(CWinwapwadDoc)
	
// Attributes

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWinwapwadDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
	void StopSession ();
	trial_data* GetTrial ();
	void NextTrial ();

	CBrush* pGreyBrush;
	CBrush* pRedBrush;
	virtual ~CWinwapwadDoc();
	virtual void Serialize(CArchive& ar);   // overridden for document i/o
	virtual void DeleteContents ();
	void SetSessionView ();
	void SetCalibrateView ();
	void CalibrationDone (double mmToXPixels, double mmToYPixels);
	void CalibrationCancel ();
	session* GetSession () {return currSess;};

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	void SetView (CRuntimeClass* classType);
	CView* GetView ();

// Generated message map functions
protected:
	//{{AFX_MSG(CWinwapwadDoc)
	afx_msg void OnStartParticipantSession();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};



/////////////////////////////////////////////////////////////////////////////
