// winwapwad.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "winwapwad.h"

#include "mainfrm.h"
#include "sconfigv.h"
#include "winwadoc.h"
#include "winwavw.h"
#include "dtd_db.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWinwapwadApp

BEGIN_MESSAGE_MAP(CWinwapwadApp, CWinApp)
	//{{AFX_MSG_MAP(CWinwapwadApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	//}}AFX_MSG_MAP
	// Standard file based document commands
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinwapwadApp construction

CWinwapwadApp::CWinwapwadApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CWinwapwadApp object

CWinwapwadApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CWinwapwadApp initialization

BOOL CWinwapwadApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.
	
	Enable3dControls();

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)
	mmToXPixels = strtod (GetProfileString ("Screen", "XPixelsPerMM"), NULL);
	if (mmToXPixels == 0.0)
	{
		WriteProfileString ("Screen", "XPixelsPerMM", "3.14961");
		mmToXPixels =   3.14961;	// 80 pixels per inch
	}
	mmToYPixels = strtod (GetProfileString ("Screen", "YPixelsPerMM"), NULL);
	if (mmToYPixels == 0.0)
	{
		WriteProfileString ("Screen", "YPixelsPerMM", "3.14961");
		mmToYPixels =   3.14961;	// 80 pixels per inch
	}

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_WINWAPTYPE,
		RUNTIME_CLASS(CWinwapwadDoc),
		RUNTIME_CLASS(CMDIChildWnd),          // standard MDI child frame
		RUNTIME_CLASS(CWinwapwadView));
//		RUNTIME_CLASS (CView));
	AddDocTemplate(pDocTemplate);

	// The following is NEVER loaded as a file;  it is only included here
	// as a means of getting this file type registered with the shell.
	pDocTemplate = new CMultiDocTemplate (
		IDR_WINWAPSUMMTYPE,
		RUNTIME_CLASS(CWinwapwadDoc),
		RUNTIME_CLASS(CMDIChildWnd),
		RUNTIME_CLASS(CWinwapwadView));
	AddDocTemplate (pDocTemplate);

	// The following is NEVER loaded as a file;  it is only included here
	// as a means of getting this file type registered with the shell.
	pDocTemplate = new CMultiDocTemplate (
		IDR_WINWAPTRAILTYPE,
		RUNTIME_CLASS(CWinwapwadDoc),
		RUNTIME_CLASS(CMDIChildWnd),
		RUNTIME_CLASS(CWinwapwadView));
	AddDocTemplate (pDocTemplate);

	RegisterShellFileTypes ();
	EnableShellOpen ();

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// create a new (empty) document
	OnFileNew();

	if (m_lpCmdLine[0] != '\0')
	{
		// TODO: add command line processing here
	}

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	return TRUE;
}


/*
	This function really should read the Version resource.  However, it's so much work to find out
	where the current file is, then get the version information, that I simply finesse it here.
	WWHENEVER YOU CHANGE THE VERSION HERE, ALSO CHANGE THE VERSION RESOURCE.
*/
CString CWinwapwadApp::Version ()
{
	return CString ("1.004");
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CWinwapwadApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CWinwapwadApp commands

void CWinwapwadApp::OnFileOpen() 
{
	// TODO: Add your command handler code here
	CWinApp::OnFileOpen();	
}

void CWinwapwadApp::OnFileSave() 
{
	// TODO: Add your command handler code here
	
}

void CWinwapwadApp::OnFileSaveAs() 
{
	// TODO: Add your command handler code here
	
}

// Implementation

void CWinwapwadApp::Calibrate (double mmToX, double mmToY)
{
	char buffer [20];

	mmToXPixels = mmToX;
	sprintf (buffer, "%f", mmToXPixels);
	WriteProfileString ("Screen", "XPixelsPerMM", buffer);

	mmToYPixels = mmToY;
	sprintf (buffer, "%f", mmToYPixels);
	WriteProfileString ("Screen", "YPixelsPerMM", buffer);
}
