// winwapwad.h : main header file for the WINWAPWAD application
//

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CWinwapwadApp:
// See winwapwad.cpp for the implementation of this class
//
class dtd_database;	// Forward declaration

class CWinwapwadApp : public CWinApp
{
//private:
	//dtd_database *dtd_db; // Must be properly initialized in the constructor

	// Conversions from device-independent to device-dependent coordinates
	double mmToXPixels;
	double mmToYPixels;

public:
	CWinwapwadApp();
	double GetMmToXPixels () {return mmToXPixels;};
	double GetMmToYPixels () { return mmToYPixels;};
	void Calibrate (double mmToXPixels, double mmToYPixels);
	CString Version ();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWinwapwadApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CWinwapwadApp)
	afx_msg void OnAppAbout();
	afx_msg void OnFileOpen();
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveAs();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

// Globally accessible utility functions
	// Convert distance from mm to horizontal pixels
	// Convert distance from mm to vertical pixels
	// Convert distance from pixels to horizontal mm
	// Convert distance from pixels to vertical mm

inline CWinwapwadApp* CurrApp ()
{
	return (CWinwapwadApp*) AfxGetApp ();
}

inline int MmToYPixels (const float dist)
{
	double mmToYPixels = ((CWinwapwadApp*)  AfxGetApp ())->GetMmToYPixels ();
	return (int) (dist * mmToYPixels + 0.5);
}

inline int MmToXPixels (const float dist)
{
	double mmToXPixels = ((CWinwapwadApp*)  AfxGetApp ())->GetMmToXPixels ();
	return (int) (dist * mmToXPixels + 0.5);
}

inline float PixToXMm (int dist)
{
	double mmToXPixels = ((CWinwapwadApp*)  AfxGetApp ())->GetMmToXPixels ();
	return (float) (dist / mmToXPixels);
}

inline float PixToYMm (int dist)
{
	double mmToYPixels = ((CWinwapwadApp*)  AfxGetApp ())->GetMmToYPixels ();
	return (float) (dist / mmToYPixels);
}
/////////////////////////////////////////////////////////////////////////////
