// winwavw.h : interface of the CWinwapwadView class
//
/////////////////////////////////////////////////////////////////////////////
class session_config_view;
class CPoint2DTrial;
class CWinwapwadDoc;
				   		
class CWinwapwadView : public CView
{
protected: // create from serialization only
	session_config_view *sc_dialog; // The dialog box for eliciting session_config info.
	CPoint2DTrial* pCurrTrial;		// The current trial, if any
	bool bWaitingForHomeClick;		// true = waiting for the user to click in home rectangle
	unsigned long ulStartTime;		// The time the user clicked in the home
	//  The home rectangle
	CPoint homeLocation;			// Center of rectangle
	CRect home;						// The whole rectangle
	//  The target circle
	CPoint targetLocation;			// Center of circle
	double targetRadius;				// Radius of circle
	CRect target;					// The bounding rectangle for the circle

	CWinwapwadView();
	DECLARE_DYNCREATE(CWinwapwadView)

// Attributes
public:
	CWinwapwadDoc* GetDocument();


// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWinwapwadView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual void OnInitialUpdate();
	protected:
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CWinwapwadView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	// Adjust the X coordinate of two CPoints, checking to see they remain in a window
	int AdjustX (int dist, CPoint& a, int aOffset, CPoint& b, int bOffset,
							 const CRect& window);
	// Adjust the Y coordinate of two CPoints, checking to see they remain in a window
	int AdjustY (int dist, CPoint& a, int aOffset, CPoint& b, int bOffset,
							 const CRect& window);
	// A trial could not be run in this CView;  tell the associated CDocument about it
	void CancelTrial ();
	// Set the cursor position to a location specified in client coordinate system
	void SetCursorPos (const CPoint& locationInClientCoords);
	// Is there a session actively running in this view?
	bool ActiveSession ();


// Generated message map functions
protected:
	//{{AFX_MSG(CWinwapwadView)
	afx_msg void OnAspectratioSet();
	afx_msg void OnFileViewandmodify();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnStopsession();
	afx_msg void OnUpdateAspectratioSet(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileViewandmodify(CCmdUI* pCmdUI);
	afx_msg void OnUpdateRunParticipantblocksequence(CCmdUI* pCmdUI);
	afx_msg void OnUpdateStopsession(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in winwavw.cpp
inline CWinwapwadDoc* CWinwapwadView::GetDocument()
   { return (CWinwapwadDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
